{===========================================================================}
{==                                                                       ==}
{==                             GBASE Version 5.2                         ==}
{==                  Copyright (C) 1994-96 By The GodFather               ==}
{==                                                                       ==}
{===========================================================================}

{$M, 16384,32767,276480}   {16Kb Stack, 270Kb Heap}

USES Dos,                          { Standart Unit }

     GUtils,
     GMemory,
     GList,
     GMenus,
     GDialogs,
     GStdDlgs;                     { GF's Units }


CONST
  Version     = 'Version 5.2';
  VersionWORD = $0500;
  DataFileID  = 'GBASE DATAFILE'#13#10#26;
  CFGFilename = 'GBASE.CFG';

  _CGA  = $01;  _ADLIB  = $01;  _8RAM  = $01;  _CRACK = $01;
  _EGA  = $02;  _SB     = $02;  _16RAM = $02;  _MARK  = $02;
  _VGA  = $04;  _SBPRO  = $04;  _486   = $04;
  _SVGA = $08;  _SB16   = $08;  _P5    = $08;
                _PAS    = $10;
                _GUS    = $20;
                _ROLAND = $40;

  MaxRecords  = 1000;
  MinMemory   = 8192;

  NameLength  = 41;
  FirmLength  = 20;
  FNameLength = 12;

  TypeLength  = 13;
  MaxTypes    = 14;
  TypesData   : ARRAY[1..MaxTypes] OF STRING[TypeLength] =
    ('3D Action'   ,'Action'  ,'Action-Scroll','Arcade'      ,'Adventure',
     'Platform'    ,'Strategy','Simulator'    ,'Simulation'  ,'Sport'    ,
     'Role-Playing','Logic'   ,'Program'      ,'Unknown type');

  SortMetodsDATA: ARRAY[1..6] OF STRING[9] =
    ('NAME','TYPE','COMPANY','FILE NAME','FULL SIZE','ARCH SIZE');

  LowMemError       = 'Not enough memory to complete operation';
  ReadHeaderError   = 'Error reading file header';
  ReadError         = 'Error reading from ';
  SaveError         = 'Error saving ';
  OpenError         = 'Error opening ';
  CreateError       = 'Error creating ';
  NotGBFileError    = ' is not GBASE datafile';
  NotFreeSpaceError = 'Not enough free space';

  Modifyed          = 'Database has been modifyed. Save?';
  DelAllMarked      = 'Delete ALL SELECTED Records?';
  DelRecord         = 'DELETE this record?';
  TooManyRecords    = 'A database can''t contain more than 1000 records';
  ASizeLarger       = 'ARCHSize is greater than FULLSize';
  FileExist         = ' already exist. Overwrite?';


TYPE
  {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
  TSortMetod = (smName,smRecType,smFirm,smFName,smFullSize,smArchSize);
  TBitInfo   = (bVideo,bSound,bHardware,bSpecial);
  TSaveRecs  = (AllRecs,SelectedOnly);                  { USED BY WriteText }
  String60   = STRING[60];
  {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
  _2Integers  = RECORD Total: LongInt; Marked: LongInt; END;
  _2LongInts  = RECORD Total: LongInt; Marked: LongInt; END;
  TGlobalInfo = RECORD
    Records   : _2Integers;
    Cracked   : _2Integers;
    ArchSize  : _2Longints;
    FullSize  : _2Longints;
  END;
  {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
  TFileHeader = RECORD
    DataID    : ARRAY[1..17] OF Char;
    UserData  : String60;
    TotalRECS : Integer;
  END;
  {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
  TFileRecord = RECORD
    Name      : STRING[NameLength];
    Firm      : STRING[FirmLength];
    FName     : STRING[FNameLength];
    RecType   : Byte;  { TypesDATA[RecType] }
    Video     : Byte;  { Bitmap - CGA EGA VGA SVGA }
    Sound     : Byte;  { Bitmap - ADLIB SB SBPRO SB16 PAS GUS ROLAND }
    Hardware  : Byte;  { Bitmap - 8RAM 16RAM 386 486 }
    Special   : Byte;  { Bitmap - CRACK MARK }
    OS        : Byte;  { OSesDATA[OS] }
    FullSize  : LongInt;
    ArchSize  : LongInt;
  END;
  {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
  PRecord    = ^TRecord;
  TRecord    = OBJECT(TObject)
    Name     : PString;
    Firm     : PString;
    FName    : PString;
    RecType  : Byte;  { TypesDATA[RecType] }
    Video    : Byte;  { Bitmap - CGA EGA VGA SVGA }
    Sound    : Byte;  { Bitmap - ADLIB SB SBPRO SB16 PAS GUS ROLAND }
    Hardware : Byte;  { Bitmap - 8RAM 16RAM 386 486 }
    Special  : Byte;  { Bitmap - CRACK MARK }
    OS       : Byte;  { OSesDATA[OS] }
    FullSize : LongInt;
    ArchSize : LongInt;
    CONSTRUCTOR Init( AName     : STRING;
                      AFirm     : STRING;
                      AFName    : STRING;
                      ARecType  : Byte;
                      AVideo    : Byte;
                      ASound    : Byte;
                      AHardware : Byte;
                      ASpecial  : Byte;
                      AOS       : Byte;
                      AFullSize : LongInt;
                      AArchSize : LongInt );
    DESTRUCTOR Done; VIRTUAL;
  END;
  {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
  PRecordsCollection = ^TRecordsCollection;
  TRecordsCollection = OBJECT(TSortedCollection)
    FileName         : String60;
    UserData         : String60;
    SortMetod        : TSortMetod;
    Ascending        : Boolean;
    FUNCTION  KeyOf(Item:Pointer): Pointer;                          VIRTUAL;
    FUNCTION  Compare(Key1,Key2:Pointer): Integer;                   VIRTUAL;
    PROCEDURE ReSort(ASortMetod:TSortMetod; AAscending:Boolean);
  END;
  {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
  PRecordsList = ^TRecordsList;
  TRecordsList = OBJECT(TList)
    FUNCTION  __GetLine     (ListPos:Integer): STRING;              VIRTUAL;
    FUNCTION  __GetSelected (ListPos:Integer): Boolean;             VIRTUAL;
    PROCEDURE __SetSelected (ListPos:Integer; Selected:Boolean);    VIRTUAL;
    PROCEDURE __IdleListCall(ListPos:Integer);                      VIRTUAL;
    PROCEDURE __HookListKeys(ListPos:Integer; VAR PressedKey:Word); VIRTUAL;
  END;
  {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
  PClipboardList = ^TClipboardList;
  TClipboardList = OBJECT(TList)
    FUNCTION  __GetLine     (ListPos:Integer): STRING;              VIRTUAL;
    PROCEDURE __IdleListCall(ListPos:Integer);                      VIRTUAL;
  END;
  {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
  TDialogDATA = RECORD
    Name      : STRING[NameLength];
    Firm      : STRING[FirmLength];
    FName     : STRING[FNameLength];
    RecType   : Word;
    FullSize  : STRING[8];
    ArchSize  : STRING[8];
    Video     : Word;
    Sound     : Word;
    Hardware  : Word;
    OS        : Word;
    Crack     : Word;
  END;
  {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}


{===========================================================================}
{=== GLOBAL VARIABLES ======================================================}
{===========================================================================}
VAR
  Database   : PRecordsCollection;
  GlobalInfo : TGlobalInfo;
  MainList   : PRecordsList;
  DlgDATA    : TDialogDATA;
  CurrentREC : Integer;

  Condensed  : Boolean;              { TRUE IF Screen is 80x50     }

  Clipboard  : PCollection;
  ClipList   : PClipboardList;

  DBChanged,                         { TRUE IF Database IS CHANGED }
  DBAllNew   : Boolean;              { TRUE IF NewDatabase IS USED }

  SaveExit   : Pointer;              { SaveExit PROCEDURE          }
  {+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}




{===========================================================================}
{=== PString ROUTINES ======================================================}
{===========================================================================}
FUNCTION AddStr(AStr: STRING): PString;
VAR PStr: PString;
BEGIN
  IF AStr = '' THEN PStr := NIL ELSE PStr := NewStr(AStr);
  AddStr := PStr;
END;

FUNCTION RetStr(AStr: PString): STRING;
BEGIN
  IF AStr = NIL THEN RetStr := '' ELSE RetStr := AStr^;
END;

PROCEDURE FreeStr(VAR AStr: PString);
BEGIN
  IF AStr <> NIL THEN DisposeStr(AStr);
END;
{+++ PString ROUTINES ++++++++++++++++++++++++++++++++++++++++++++++++++++++}




{===========================================================================}
{=== TRecord OBJECT PROCEDURES =============================================}
{===========================================================================}
FUNCTION GetFlag(ARecord:PRecord; Info:TBitInfo; Flag:Word): Boolean;
BEGIN
  WITH ARecord^ DO
  CASE Info OF
    bVideo   : GetFlag := (Video    AND Flag) <> 0;
    bSound   : GetFlag := (Sound    AND Flag) <> 0;
    bHardware: GetFlag := (Hardware AND Flag) <> 0;
    bSpecial : GetFlag := (Special  AND Flag) <> 0;
  END;
END;

PROCEDURE SetFlag(ARecord:PRecord; Info:TBitInfo; Flag:Word; OK:Boolean);
BEGIN
  WITH ARecord^ DO
  CASE Info OF
    bVideo   : IF OK THEN Video    := (Video    OR Flag) ELSE Video    := (Video    AND NOT Flag);
    bSound   : IF OK THEN Sound    := (Sound    OR Flag) ELSE Sound    := (Sound    AND NOT Flag);
    bHardware: IF OK THEN Hardware := (Hardware OR Flag) ELSE Hardware := (Hardware AND NOT Flag);
    bSpecial : IF OK THEN Special  := (Special  OR Flag) ELSE Special  := (Special  AND NOT Flag);
  END;
END;

FUNCTION GetMarked(ARecord:PRecord): Boolean;
BEGIN
  GetMarked := GetFlag(ARecord,bSpecial,_MARK);
END;

PROCEDURE SetMarked(ARecord:PRecord; OK:Boolean);
BEGIN
  SetFlag(ARecord,bSpecial,_MARK,OK);
END;

FUNCTION GetCracked(ARecord:PRecord): Boolean;
BEGIN
  GetCracked := GetFlag(ARecord,bSpecial,_CRACK);
END;

FUNCTION GetType(ARecord:PRecord): STRING;
BEGIN
  WITH ARecord^ DO
    BEGIN
      GetType := TypesDATA[RecType];
    END;
END;

FUNCTION GetFirm(ARecord:PRecord): STRING;
BEGIN
  WITH ARecord^ DO
    BEGIN
      IF Firm = NIL THEN GetFirm := '-' ELSE GetFirm := Firm^;
    END;
END;

FUNCTION GetFName(ARecord:PRecord): STRING;
BEGIN
  WITH ARecord^ DO
    BEGIN
      IF FName = NIL THEN GetFName := '-' ELSE GetFName := FName^;
    END;
END;

CONSTRUCTOR TRecord.Init( AName     : STRING;
                          AFirm     : STRING;
                          AFName    : STRING;
                          ARecType  : Byte;
                          AVideo    : Byte;
                          ASound    : Byte;
                          AHardware : Byte;
                          ASpecial  : Byte;
                          AOS       : Byte;
                          AFullSize : LongInt;
                          AArchSize : LongInt );
BEGIN
  Name     := AddStr(AName);
  Firm     := AddStr(AFirm);
  FName    := AddStr(AFName);
  RecType  := ARecType;
  Video    := AVideo;
  Sound    := ASound;
  Hardware := AHardware;
  Special  := ASpecial;
  OS       := AOS;
  FullSize := AFullSize;
  ArchSize := AArchSize;
END;

DESTRUCTOR TRecord.Done;
BEGIN
  FreeStr(Name);
  FreeStr(Firm);
  FreeStr(FName);
END;
{+++ END OF TRecord OBJECT PROCEDURES ++++++++++++++++++++++++++++++++++++++}





{===========================================================================}
{=== TRecordsCollection PROCEDURES =========================================}
{===========================================================================}
FUNCTION TRecordsCollection.KeyOf(Item:Pointer): Pointer;
BEGIN
  CASE SortMetod OF
        smName: KeyOf := @PRecord(Item)^.Name;
     smRecType: KeyOf := @PRecord(Item)^.RecType;
        smFirm: KeyOf := @PRecord(Item)^.Firm;
       smFName: KeyOf := @PRecord(Item)^.FName;
    smFullSize: KeyOf := @PRecord(Item)^.FullSize;
    smArchSize: KeyOf := @PRecord(Item)^.ArchSize;
  END;
END;

FUNCTION TRecordsCollection.Compare(Key1,Key2:Pointer): Integer;
VAR F,N: Integer;
BEGIN
  IF Ascending
    THEN BEGIN F := -1; N :=  1; END
    ELSE BEGIN F :=  1; N := -1; END;
  CASE SortMetod OF
     smName,
     smFirm,
    smFName: IF PString(Key1^)^ = PString(Key2^)^
                THEN Compare := 0
                ELSE IF PString(Key1^)^ < PString(Key2^)^
                        THEN Compare := F
                        ELSE Compare := N;
  smRecType: IF Byte(Key1^) = Byte(Key2^)
                THEN Compare := 0
                ELSE IF Byte(Key1^) < Byte(Key2^)
                        THEN Compare := F
                        ELSE Compare := N;
 smFullSize,
 smArchSize: IF LongInt(Key1^) = LongInt(Key2^)
                THEN Compare := 0
                ELSE IF LongInt(Key1^) < LongInt(Key2^)
                        THEN Compare := F
                        ELSE Compare := N;
  END;
END;

PROCEDURE TRecordsCollection.ReSort(ASortMetod:TSortMetod; AAscending:Boolean);
VAR ARecord:PRecord; TMPCollection:PRecordsCollection;
BEGIN
  IF (ASortMetod = SortMetod) AND (AAscending = Ascending) THEN Exit;
  New(TMPCollection, Init(1,1));
  TMPCollection^.Duplicates:= True;
  TMPCollection^.FileName  := FileName;
  TMPCollection^.UserData  := UserData;
  TMPCollection^.SortMetod := ASortMetod;
  TMPCollection^.Ascending := AAscending;
  REPEAT
    ARecord := Database^.At(0);
    WITH ARecord^ DO
     TMPCollection^.Insert( New(PRecord,
                                Init(RetStr(Name),RetStr(Firm),RetStr(FName),
                                     RecType,Video,Sound,Hardware,Special,OS,
                                     FullSize,ArchSize)));
    Database^.AtFree(0);
  UNTIL Database^.Count = 0;
  Dispose(Database, Done);
  Database := TMPCollection;
END;

PROCEDURE Sort;
VAR Key: Word; MPos: Byte; I: Word; UpY: Byte;
BEGIN
  IF GlobalInfo.Records.Total = 1 THEN Exit;

  UpY := MaxY DIV 2 - 5;
  OpenWin(36,UpY,12,7,$5D,$5F,Special2,'Sort by');
  FOR I:=1 TO 6 DO FastWrite(38,UpY+I,$57,SortMetodsDATA[I]);
  MPos := Ord(Database^.SortMetod)+1;
  REPEAT
    Attribute(37,UpY+MPos,$20,11);
    Key := GetKey;
    Attribute(37,UpY+MPos,$57,11);
    CASE Key OF
      kbUp: BEGIN Dec(MPos); IF MPos<1 THEN MPos:=6; END;
    kbDown: BEGIN Inc(MPos); IF MPos>6 THEN MPos:=1; END;
   kbEnter: BEGIN
              WITH Database^ DO
              CASE MPos OF
                1: BEGIN ReSort(smName    ,Ascending); ModifyItemParam(4,11,SortMetodsDATA[1]); END;
                2: BEGIN ReSort(smRecType ,Ascending); ModifyItemParam(4,11,SortMetodsDATA[2]); END;
                3: BEGIN ReSort(smFirm    ,Ascending); ModifyItemParam(4,11,SortMetodsDATA[3]); END;
                4: BEGIN ReSort(smFName   ,Ascending); ModifyItemParam(4,11,SortMetodsDATA[4]); END;
                5: BEGIN ReSort(smFullSize,Ascending); ModifyItemParam(4,11,SortMetodsDATA[5]); END;
                6: BEGIN ReSort(smArchSize,Ascending); ModifyItemParam(4,11,SortMetodsDATA[6]); END;
              END;
            END;
    END;
    Attribute(37,UpY+MPos,$20,11);
  UNTIL (Key=kbEnter) OR (Key=kbEsc);
  RmWin;
  IF Key = kbEnter THEN MainList^.ReDraw;
END;
{+++ END OF TRecordsCollection PROCEDURES ++++++++++++++++++++++++++++++++++}






{===========================================================================}
{=== UPDATE GlobalInfo =====================================================}
{===========================================================================}
PROCEDURE UpdateGlobalInfo;
VAR Index: Integer; ARecord: PRecord;
BEGIN
  FillChar(GlobalInfo,SizeOf(GlobalInfo),0);
  IF Database^.Count = 0 THEN Exit;
  FOR Index := 0 TO Database^.Count-1 DO
  BEGIN
    ARecord := Database^.At(Index);
    WITH ARecord^ DO
    BEGIN
      Inc(GlobalInfo.Records.Total);
      IF GetCracked(ARecord) THEN Inc(GlobalInfo.Cracked.Total);
      Inc(GlobalInfo.FullSize.Total,FullSize DIV 1024);
      Inc(GlobalInfo.ArchSize.Total,ArchSize DIV 1024);

      IF GetMarked(ARecord) THEN
      BEGIN
        Inc(GlobalInfo.Records.Marked);
        IF GetCracked(ARecord) THEN Inc(GlobalInfo.Cracked.Marked);
        Inc(GlobalInfo.FullSize.Marked,FullSize DIV 1024);
        Inc(GlobalInfo.ArchSize.Marked,ArchSize DIV 1024);
      END;
    END;
  END;
END;


PROCEDURE ModifyMenu;
VAR Disabled: Boolean;
BEGIN
  IF (GlobalInfo.Records.Total = 1) OR
     (GlobalInfo.Records.Marked= 0) OR
     (GlobalInfo.Records.Total = GlobalInfo.Records.Marked) THEN Disabled := True ELSE Disabled := False;
  ModifyItemDisabled(3,1,Disabled); {Cut}
  ModifyItemDisabled(4,5,Disabled); {Delete selected}

  IF GlobalInfo.Records.Marked = 0 THEN Disabled := True ELSE Disabled := False;
  ModifyItemDisabled(2,7,Disabled); {Save selected as text}
  ModifyItemDisabled(3,2,Disabled); {Copy}
  ModifyItemDisabled(4,6,Disabled); {Select all}

  IF Clipboard=NIL THEN Disabled := True ELSE Disabled := False;
  ModifyItemDisabled(3,3,Disabled); {Paste}
  ModifyItemDisabled(3,5,Disabled); {View clipboard}
  ModifyItemDisabled(3,7,Disabled); {Empty clipboard}

  IF GlobalInfo.Records.Total = 1 THEN Disabled := True ELSE Disabled := False;
  ModifyItemDisabled(4, 3,Disabled); {Del record}
  ModifyItemDisabled(4,13,Disabled); {Sort by...}
  ModifyItemDisabled(4,14,Disabled); {Sorting order}

  IF Database^.Ascending
    THEN ModifyItemParam(4,14,'ASCENDING')
    ELSE ModifyItemParam(4,14,'DESCENDING'); {Sorting order}
END;
{+++ END OF UPDATE GlobalInfo ++++++++++++++++++++++++++++++++++++++++++++++}





{===========================================================================}
{=== DRAW SCREENS ==========================================================}
{===========================================================================}
PROCEDURE About;
VAR OK: PButtons; Y: Byte;
BEGIN
  Y := MaxY DIV 2 - 9;
  OpenWin(11,Y,60,20,$5D,$5F,Double1,'About');
  WriteBetween(12,70,Y+1,$5A,'Ŀ             ');
  WriteBetween(12,70,Y+2,$5A,'   ֿ ĿĿĿ');
  WriteBetween(12,70,Y+3,$5A,' ڿĴķ ');
  WriteBetween(12,70,Y+4,$5A,' Ľ');
  WriteBetween(12,70,Y+5,$5E,Version);
  WriteBetween(12,70,Y+6,$5E,'Copyright (C) 1994-96 By The GodFather');
  WriteBetween(12,70,Y+8,$57,'If you have bug-reports, suggestion or comments');
  WriteBetween(12,70,Y+9,$57,'please write to me. I`ll be happy to answer you');
  WriteBetween(12,70,Y+11,$57,' Contact me here: ');
  WriteBetween(12,70,Y+13,$5B,' Email: gf@top.bg ');
  WriteBetween(12,70,Y+14,$5B,' Email: gf@cybcom.net ');
  WriteBetween(12,70,Y+15,$5B,' URL: http://georgi.top.bg/ ');
  InitPallette(DefaultDialogPAL);
  OK := New(PButtons, Init);
  OK^.AddBtn('    ~O~K    ',kbAltO,36,Y+18,btDefault);
  OK^.Process;
  Dispose(OK,Done);
  PosCursor(80,MaxY);
  RmWin;
END;



PROCEDURE Help(HelpNum:Byte);
VAR A,I,R:Byte; X,X2,Y:Byte; B:Boolean; Key:Word; MX1,MX2,MX3: Byte;

  PROCEDURE _Global;
  BEGIN
    Box(X+5,Y+2,X+55,Y+8,$5D,Single1);
    FastWrite(X+6,Y+2,$5E,' Global ');
    WriteHi(X+X2,Y+3,$57,$5A,PadLeft(' ~F1~        Help',51,' '));
    WriteHi(X+X2,Y+4,$57,$5A,PadLeft(' ~F9~        About program',51,' '));
    WriteHi(X+X2,Y+5,$57,$5A,PadLeft(' ~F10~       Open last used menu',51,' '));
    WriteHi(X+X2,Y+6,$57,$5A,PadLeft(' ~Alt+F9~    Switch NORMAL/CONDENSED screen',51,' '));
    WriteHi(X+X2,Y+7,$57,$5A,PadLeft(' ~Esc~       Quit GBASE',51,' '));
    FastWrite(X+5,Y+9 ,$5D,Replicate(51,' '));
    FastWrite(X+5,Y+10,$5D,Replicate(51,' '));
    WriteHi(MX1,Y+12,I,R,'   ~G~lobal      ');
  END;

  PROCEDURE _File;
  BEGIN
    Box(X+5,Y+2,X+55,Y+10,$5D,Single1);
    FastWrite(X+6,Y+2,$5E,' File ');
    WriteHi(X+X2,Y+3,$57,$5A,PadLeft(' ~F2~        Save',51,' '));
    WriteHi(X+X2,Y+4,$57,$5A,PadLeft(' ~Shift+F2~  Save as...',51,' '));
    WriteHi(X+X2,Y+5,$57,$5A,PadLeft(' ~F3~        Load...',51,' '));
    WriteHi(X+X2,Y+6,$57,$5A,PadLeft(' ~F4~        Save text file',51,' '));
    WriteHi(X+X2,Y+7,$57,$5A,PadLeft(' ~F5~        Save taged only in text file',51,' '));
    WriteHi(X+X2,Y+8,$57,$5A,PadLeft(' ~F6~        Save DESCRIPT.ION file',51,' '));
    WriteHi(X+X2,Y+9,$57,$5A,PadLeft(' ~F7~        Save advanced DESCRIPTION.ION file',51,' '));
    WriteHi(MX2,Y+12,I,R,'   ~F~ile        ');
  END;

  PROCEDURE _Clipboard;
  BEGIN
    Box(X+5,Y+2,X+55,Y+8,$5D,Single1);
    FastWrite(X+6,Y+2,$5E,' Clipboard ');
    WriteHi(X+X2,Y+3,$57,$5A,PadLeft(' ~Ctrl+X~    Cut',51,' '));
    WriteHi(X+X2,Y+4,$57,$5A,PadLeft(' ~Ctrl+C~    Copy',51,' '));
    WriteHi(X+X2,Y+5,$57,$5A,PadLeft(' ~Ctrl+V~    Paste',51,' '));
    WriteHi(X+X2,Y+6,$57,$5A,PadLeft(' ~Ctrl+F10~  View clipboard',51,' '));
    WriteHi(X+X2,Y+7,$57,$5A,PadLeft(' ~Ctrl+E~    Empty clipboard',51,' '));
    FastWrite(X+5,Y+09,$5D,Replicate(51,' '));
    FastWrite(X+5,Y+10,$5D,Replicate(51,' '));
    WriteHi(MX3,Y+13,I,R,'   ~C~lipboard   ');
  END;

  PROCEDURE _Database;
  BEGIN
    Box(X+5,Y+2,X+55,Y+10,$5D,Single1);
    FastWrite(X+6,Y+2,$5E,' Database ');
    WriteHi(X+X2,Y+3,$57,$5A,PadLeft(' ~Ins~       Add record',51,' '));
    WriteHi(X+X2,Y+4,$57,$5A,PadLeft(' ~Tab~       Edit current record',51,' '));
    WriteHi(X+X2,Y+5,$57,$5A,PadLeft(' ~Del~       Delete current record',51,' '));
    WriteHi(X+X2,Y+6,$57,$5A,PadLeft(' ~Ctrl+D~    Delete selected records',51,' '));
    WriteHi(X+X2,Y+7,$57,$5A,PadLeft(' ~Ctrl+B~    Edit database description',51,' '));
    WriteHi(X+X2,Y+8,$57,$5A,PadLeft(' ~Ctrl+S~    Sort database by...',51,' '));
    WriteHi(X+X2,Y+9,$57,$5A,PadLeft(' ~Ctrl+O~    Change sorting order',51,' '));
    WriteHi(MX1,Y+13,I,R,'   ~D~atabase    ');
  END;

  PROCEDURE _Selection;
  BEGIN
    Box(X+5,Y+2,X+55,Y+7,$5D,Single1);
    FastWrite(X+6,Y+2,$5E,' Selection ');
    WriteHi(X+X2,Y+3,$57,$5A,PadLeft(' ~Space~     Select record',51,' '));
    WriteHi(X+X2,Y+4,$57,$5A,PadLeft(' ~Ctrl+A~    Select all records',51,' '));
    WriteHi(X+X2,Y+5,$57,$5A,PadLeft(' ~Ctrl+U~    UNSelect all records',51,' '));
    WriteHi(X+X2,Y+6,$57,$5A,PadLeft(' ~Ctrl+I~    Invert selection',51,' '));
    FastWrite(X+5,Y+8 ,$5D,Replicate(51,' '));
    FastWrite(X+5,Y+9 ,$5D,Replicate(51,' '));
    FastWrite(X+5,Y+10,$5D,Replicate(51,' '));
    WriteHi(MX2,Y+13,I,R,'   ~S~election   ');
  END;

  PROCEDURE _Dialog;
  BEGIN
    Box(X+5,Y+2,X+55,Y+9,$5D,Single1);
    FastWrite(X+6,Y+2,$5E,' Dialog ');
    WriteHi(X+X2,Y+3,$57,$5A,PadLeft(' ~Ctrl+Z~    Undo',51,' '));
    WriteHi(X+X2,Y+4,$57,$5A,PadLeft(' ~Ctrl+Back~ Delete text field',51,' '));
    WriteHi(X+X2,Y+5,$57,$5A,PadLeft(' ~Tab~       Next field',51,' '));
    WriteHi(X+X2,Y+6,$57,$5A,PadLeft(' ~Shift+Tab~ Previos field',51,' '));
    WriteHi(X+X2,Y+7,$57,$5A,PadLeft(' ~Enter~     OK',51,' '));
    WriteHi(X+X2,Y+8,$57,$5A,PadLeft(' ~Esc~       Cancel',51,' '));
    FastWrite(X+5,Y+10,$5D,Replicate(51,' '));
    WriteHi(MX3,Y+12,I,R,'   D~i~alog      ');
  END;

  PROCEDURE Show;
  BEGIN
    WriteHi(MX1,Y+12,$57,$5F,'   ~G~lobal      ');
    WriteHi(MX1,Y+13,$57,$5F,'   ~D~atabase    ');
    WriteHi(MX2,Y+12,$57,$5F,'   ~F~ile        ');
    WriteHi(MX2,Y+13,$57,$5F,'   ~S~election   ');
    WriteHi(MX3,Y+12,$57,$5F,'   D~i~alog      ');
    WriteHi(MX3,Y+13,$57,$5F,'   ~C~lipboard   ');
    CASE A OF
      1: IF B THEN _Global ELSE _Database;
      2: IF B THEN _File   ELSE _Selection;
      3: IF B THEN _Dialog ELSE _Clipboard;
    END;
  END;

BEGIN
  X := 10; X2 := 6;
  Y := MaxY DIV 2-7;
  A := 1; B := True;
  I := $D7; R := $DF;
  CASE HelpNum OF
    1: BEGIN A := 1; B := True; END;
    2: BEGIN A := 2; B := True; END;
    3: BEGIN A := 3; B := True; END;
    4: BEGIN A := 1; B := False; END;
    5: BEGIN A := 2; B := False; END;
    6: BEGIN A := 3; B := False; END;
  END;
  MX1 := X+8; MX2 := X+23; MX3 := X+38;
  OpenWin(X,Y,60,15,$5D,$5B,Double1,'Help');
  REPEAT
    Show;
    Key := GetKey;
    CASE Key OF
      1: IF B THEN _Global ELSE _Database;
      2: IF B THEN _File   ELSE _Selection;
      3: IF B THEN _Dialog ELSE _Clipboard;
Ord('g'),Ord('G'): BEGIN A := 1; B := True; END;
Ord('f'),Ord('F'): BEGIN A := 2; B := True; END;
Ord('i'),Ord('I'): BEGIN A := 3; B := True; END;
Ord('d'),Ord('D'): BEGIN A := 1; B := False; END;
Ord('s'),Ord('S'): BEGIN A := 2; B := False; END;
Ord('c'),Ord('C'): BEGIN A := 3; B := False; END;
      kbLeft: IF A = 1 THEN A := 3 ELSE Dec(A);
     kbRight: IF A = 3 THEN A := 1 ELSE Inc(A);
        kbUp,
      kbDown: B := NOT B;
    END;
  UNTIL (Key=kbEnter) OR (Key=kbEsc);
  RmWin;
END;


FUNCTION BeginNewDatabase: Byte;
VAR Key:Word; NewData:Boolean; X,Y,Attr:Byte;

  PROCEDURE WriteShadows;
  BEGIN
    FastWrite (X+5 ,Y+ 5,$00,Replicate(18,' '));
    FastWrite (X+21,Y+ 2,Attr,'  ');
    FastWrite (X+21,Y+ 3,$00,'  ');
    FastWrite (X+21,Y+ 4,$00,'  ');
    FastWrite (X+21,Y+ 5,$00,'  ');
    FastWrite (X+5 ,Y+11,$00,Replicate(18,' '));
    FastWrite (X+21,Y+ 8,Attr,'  ');
    FastWrite (X+21,Y+ 9,$00,'  ');
    FastWrite (X+21,Y+10,$00,'  ');
    FastWrite (X+21,Y+11,$00,'  ');
  END;

  PROCEDURE WriteData;
  BEGIN
    IF NewData
      THEN BEGIN
             ClearAttr(X+3,Y+8,X+20,Y+10,$70);
             ClearAttr(X+3,Y+2,X+20,Y+4,$F0);
             WriteHi(X+5,Y+9,$70,$74,'~L~oad database');
             WriteHi(X+6,Y+3,$F0,$F4,'~N~ew database');
           END
      ELSE BEGIN
             ClearAttr(X+3,Y+2,X+20,Y+4,$70);
             ClearAttr(X+3,Y+8,X+20,Y+10,$F0);
             WriteHi(X+6,Y+3,$70,$74,'~N~ew database');
             WriteHi(X+5,Y+9,$F0,$F4,'~L~oad database');
           END;
  END;

  PROCEDURE Push;
  BEGIN
    IF NewData
      THEN BEGIN
             MoveScreenBlock (X+3,Y+2,X+20,Y+4,X+5,Y+2,' ');
             FastWrite       (X+5,Y+5,Attr,Replicate(18,' '));
             WriteVert       (X+3,Y+2,Attr,'   ');
           END
      ELSE BEGIN
             MoveScreenBlock (X+3,Y+8 ,X+20,Y+10,X+5,Y+8,' ');
             FastWrite       (X+5,Y+11,Attr,Replicate(18,' '));
             WriteVert       (X+3,Y+8 ,Attr,'   ');
           END;
    Wait(2);
    IF NewData
      THEN MoveScreenBlock   (X+5,Y+2,X+20,Y+4,X+3,Y+2,' ')
      ELSE MoveScreenBlock   (X+5,Y+8,X+20,Y+10,X+3,Y+8,' ');
    WriteShadows;
    Wait(4);
  END;

BEGIN
  NewData := False;
  X := 28; Y := MaxY DIV 2-5; Attr := $19;
  OpenWin(X-1,Y,26,13,Attr,$1F,Single1,'GBASE');
  WriteData;
  WriteShadows;
  REPEAT
    Key := GetKey;
    CASE Key OF
    Ord('N'),
    Ord('n'): BEGIN NewData := True;  Key := kbEnter; END;
        kbF3,
    Ord('L'),
    Ord('l'): BEGIN NewData := False; Key := kbEnter; END;
      kbUp,
      kbDown: NewData := NOT NewData;
     kbSpace: Key := kbEnter;
    END;
    WriteData;
  UNTIL (Key=kbEnter) OR (Key=kbEsc);
  IF Key=kbEnter THEN Push;
  IF NewData THEN BeginNewDatabase := 1 ELSE BeginNewDatabase := 2;
  IF Key=kbEsc THEN BeginNewDatabase := 3;
  RmWin;
END;



PROCEDURE DrawMAINScreen;
BEGIN
  PosCursor(80,MaxY);
  ClearLine(1,$07);

  FBox(1,2,80,MaxY,$19,Double1);
  FastWrite(22,2,$1B,' Name ');
  FastWrite(48,2,$1B,' Type ');
  FastWrite(63,2,$1B,' Created by ');

  SmartHLine (1,80,MaxY-11,$19,DoubleLine);
  SmartHLine (1,80,MaxY-3 ,$19,DoubleLine);
  SmartVLine (42,MaxY-11,MaxY-3,$19,DoubleLine);

  SmartVLine (12,MaxY-11,MaxY-3,$19,SingleLine); WriteVert(12,MaxY-10,$19,Replicate(7,#197));
  SmartVLine (59,MaxY-11,MaxY-3,$19,SingleLine); WriteVert(59,MaxY-10,$19,Replicate(7,#197));
  SmartVLine (16,MaxY-3,MaxY,$19,SingleLine);    WriteVert(16,MaxY-2,$19,Replicate(2,#197));

  FastWrite(3,MaxY-10,$1E,'    File'); FastWrite(44,MaxY-10,$1E,'TAGED Records');
  FastWrite(3,MaxY-9 ,$1E,'   Video'); FastWrite(44,MaxY-9 ,$1E,'      FullSize');
  FastWrite(3,MaxY-8 ,$1E,'   Sound'); FastWrite(44,MaxY-8 ,$1E,'      ArchSize');
  FastWrite(3,MaxY-7 ,$1E,'Hardware'); FastWrite(44,MaxY-7 ,$1E,'TOTAL Records');
  FastWrite(3,MaxY-6 ,$1E,'      OS'); FastWrite(44,MaxY-6 ,$1E,'      FullSize');
  FastWrite(3,MaxY-5 ,$1E,'FullSize'); FastWrite(44,MaxY-5 ,$1E,'      ArchSize');
  FastWrite(3,MaxY-4 ,$1E,'ArchSize'); FastWrite(44,MaxY-4 ,$1F,'DATA SORTED BY');

  FastWrite(3,MaxY-2,$1E,'Current file');
  FastWrite(3,MaxY-1,$1E,' Description');

  ClearAttr(43,MaxY-10,49,MaxY-5,$1F);
END;



PROCEDURE DrawInformation(ARecord:PRecord);
VAR ASC: STRING[11];
{}PROCEDURE SmartWrite(X,Y:Byte; S:STRING); BEGIN FastWrite(X,Y,$13,S+Replicate(19-Length(S),' ')); END;
BEGIN
  WITH GlobalInfo DO
  BEGIN
    SmartWrite(61,MaxY-10,AddComas(Records.Marked ));
    SmartWrite(61,MaxY-9 ,AddComas(FullSize.Marked)+' KB');
    SmartWrite(61,MaxY-8 ,AddComas(ArchSize.Marked)+' KB');
    SmartWrite(61,MaxY-7 ,AddComas(Records.Total ));
    SmartWrite(61,MaxY-6 ,AddComas(FullSize.Total)+' KB');
    SmartWrite(61,MaxY-5 ,AddComas(ArchSize.Total)+' KB');
    IF Database^.Ascending THEN ASC := '     [Asc]' ELSE ASC := '    [Desc]';
    FastWrite (61,MaxY-4,$13,PadLeft(SortMetodsDATA[Ord(Database^.SortMetod)+1],9,' ')+ASC);
  END;
  WITH ARecord^ DO
  BEGIN
    SmartWrite(14,MaxY-10,GetFName(ARecord));
    IF GetFlag(ARecord,bVideo,_CGA     ) THEN FastWrite(14,MaxY-9,$13,'CGA')      ELSE FastWrite(14,MaxY-9,$18,'cga');
    IF GetFlag(ARecord,bVideo,_EGA     ) THEN FastWrite(18,MaxY-9,$13,'EGA')      ELSE FastWrite(18,MaxY-9,$18,'ega');
    IF GetFlag(ARecord,bVideo,_VGA     ) THEN FastWrite(22,MaxY-9,$13,'VGA')      ELSE FastWrite(22,MaxY-9,$18,'vga');
    IF GetFlag(ARecord,bVideo,_SVGA    ) THEN FastWrite(26,MaxY-9,$13,'SuperVGA') ELSE FastWrite(26,MaxY-9,$18,'supervga');
    IF GetFlag(ARecord,bSound,_ADLIB   ) THEN FastWrite(14,MaxY-8,$13,'AD')       ELSE FastWrite(14,MaxY-8,$18,'ad');
    IF GetFlag(ARecord,bSound,_SB      ) THEN FastWrite(17,MaxY-8,$13,'SB')       ELSE FastWrite(17,MaxY-8,$18,'sb');
    IF GetFlag(ARecord,bSound,_SBPRO   ) THEN FastWrite(20,MaxY-8,$13,'SBP')      ELSE FastWrite(20,MaxY-8,$18,'sbp');
    IF GetFlag(ARecord,bSound,_SB16    ) THEN FastWrite(24,MaxY-8,$13,'SB16')     ELSE FastWrite(24,MaxY-8,$18,'sb16');
    IF GetFlag(ARecord,bSound,_PAS     ) THEN FastWrite(29,MaxY-8,$13,'PAS')      ELSE FastWrite(29,MaxY-8,$18,'pas');
    IF GetFlag(ARecord,bSound,_GUS     ) THEN FastWrite(33,MaxY-8,$13,'GUS')      ELSE FastWrite(33,MaxY-8,$18,'gus');
    IF GetFlag(ARecord,bSound,_ROLAND  ) THEN FastWrite(37,MaxY-8,$13,'RD')       ELSE FastWrite(37,MaxY-8,$18,'rd');
    IF GetFlag(ARecord,bHardware,_8RAM ) THEN FastWrite(14,MaxY-7,$13,'8RAM')     ELSE FastWrite(14,MaxY-7,$18,'8ram');
    IF GetFlag(ARecord,bHardware,_16RAM) THEN FastWrite(19,MaxY-7,$13,'16RAM')    ELSE FastWrite(19,MaxY-7,$18,'16ram');
    IF GetFlag(ARecord,bHardware,_486  ) THEN FastWrite(25,MaxY-7,$13,'486')      ELSE FastWrite(25,MaxY-7,$18,'486');
    IF GetFlag(ARecord,bHardware,_P5   ) THEN FastWrite(29,MaxY-7,$13,'P5')       ELSE FastWrite(29,MaxY-7,$18,'p5');
    IF GetCracked(ARecord)               THEN FastWrite(32,MaxY-7,$13,'CRACKED')  ELSE FastWrite(32,MaxY-7,$18,'cracked');
    FastWrite(14,MaxY-6,$18,'dos win31 win95 os/2');
    CASE OS OF
      1: FastWrite(14,MaxY-6,$13,'DOS');
      2: FastWrite(18,MaxY-6,$13,'WIN31');
      3: FastWrite(24,MaxY-6,$13,'WIN95');
      4: FastWrite(30,MaxY-6,$13,'OS/2');
    END;
    SmartWrite(14,MaxY-5,AddComas(FullSize)+' Bytes');
    SmartWrite(14,MaxY-4,AddComas(ArchSize)+' Bytes');
  END;
  FastWrite(18,MaxY-2,$1B,PadLeft(Database^.FileName,60,' '));
  FastWrite(18,MaxY-1,$1B,PadLeft(Database^.UserData,60,' '));
  IF DBChanged
    THEN FastWrite(76,MaxY,$1C,' '#15' ')
    ELSE FastWrite(76,MaxY,$19,'');
  IF DBAllNew
    THEN FastWrite(70,MaxY,$1C,' NEW ')
    ELSE FastWrite(70,MaxY,$19,'');
  ModifyMenu;
END;



PROCEDURE SetScreen(ACondensed:Boolean);
BEGIN
  ClrScr(7);
  Cursor(Off);
  IF ACondensed<>Condensed THEN
    IF ACondensed
      THEN SetCondensedLines
      ELSE SetNormalLines;
  Cursor(Off);
  PosCursor(80,MaxY);
  SetBlink(False);

  Condensed := ACondensed;
  SetPal(AltPAL);
  DrawMainScreen;
  DrawMenuBar;

  MainList^.FastFindY  := MaxY-11;
  MainList^.ScrollerY2 := MaxY-12;
  MainList^.ChangeMaxTopics(MaxY-14,Database^.Count);
END;


{
PROCEDURE DosShell;
VAR Error:Integer; ARecord:PRecord;
BEGIN
  FastWrite(1,1,7,AddComas(MemAvail));
  Pause;
  ClrScr(7);
  SetPAL(OrgPAL);
  Cursor(On);
  SetBlink(True);
  Writeln;
  Writeln;
  Writeln;
  WriteCenter(1,$0E,'DOS Shell');
  WriteCenter(2,$0E,'Type EXIT to return in GBASE');
  SetBorderColor($01);
  Error := ShellToDOS;
  SetBorderColor($00);
  SetScreen(Condensed);
  ARecord := Database^.At(CurrentREC);
  DrawInformation(ARecord);
  IF Error <> 0 THEN InfoBox('DOS error '+IntToStr(Error),True);
END;
}
{+++ END OF DRAW SCREENS +++++++++++++++++++++++++++++++++++++++++++++++++++}




{===========================================================================}
{=== Dispose dynamic data ==================================================}
{===========================================================================}
PROCEDURE DisposeClipboard;
BEGIN
  IF Clipboard <> NIL THEN
  BEGIN
    Dispose(Clipboard, Done);
    Clipboard := NIL;
  END ELSE Clipboard := NIL;
END;

PROCEDURE DisposeDatabase;
BEGIN
  IF Database <> NIL THEN
  BEGIN
    Dispose(Database, Done);
    Database := NIL;
  END ELSE Database := NIL;
END;

PROCEDURE DisposeMainList;
BEGIN
  IF MainList <> NIL THEN
  BEGIN
    Dispose(MainList, Done);
    MainList := NIL;
  END ELSE MainList := NIL;
END;

PROCEDURE DisposeALL;
BEGIN
  DisposeClipboard;
  DisposeDatabase;
  DisposeMainList;
END;

PROCEDURE InitDatabase;
BEGIN
  DisposeDatabase;
  New(Database, Init(1,1));
  Database^.Duplicates := True;
  Database^.FileName   := '';
  Database^.UserData   := '';
  Database^.SortMetod  := smName;
  Database^.Ascending  := True;
END;
{+++ Dispose dynamic data ++++++++++++++++++++++++++++++++++++++++++++++++++}





{===========================================================================}
{=== GAUGE procedures ======================================================}
{===========================================================================}
PROCEDURE UpdateGauge(Current,Max:LongInt);
BEGIN
  PlainWrite(39,MaxY DIV 2+1,AddComas(RetPercent(100,Max,Current))+'%');
  Attribute (16,MaxY DIV 2+1,$F0,(RetPercent(50,Max,Current)));
END;

PROCEDURE InitGauge(Title:STRING);
VAR Y:Byte;
BEGIN
  Y := MaxY DIV 2-3;
  OpenWin(11,Y,60,6,$93,$9B,Double1,'Progress indicator');
  WriteBetween(11,71,Y+2,$9E,Title);
  FastWrite(16,Y+4,$07,Replicate(50,' '));
END;

PROCEDURE DoneGauge;
BEGIN
  RmWin;
END;
{+++ GAUGE procedures ++++++++++++++++++++++++++++++++++++++++++++++++++++++}




{===========================================================================}
{=== Change FILENAME =======================================================}
{===========================================================================}
FUNCTION Edit(EditFile:Boolean): Boolean; {TRUE - FILENAME ___ FALSE - USERDATA}
VAR I,Result:Integer; EditD:PDialog; UserData:String60; FileName:String60;
BEGIN
  IF EditFile THEN I := 1 ELSE I := 2;
  FileName := Database^.FileName;
  UserData := Database^.UserData;
  New(EditD, Init(6,MaxY DIV 2-6,69,12,DefaultDialogPAL,Single1,'Edit'));
  WITH EditD^ DO
  BEGIN
    AddTxtInputLine(5,3,'Data~f~ile full name:'   ,kbAltF,3,4,60,ilFileName,FileName);
    AddTxtInputLine(5,6,'Datafile ~d~escription:' ,kbAltD,3,7,60,ilNormal,UserData);
    AddButtons;
       AddButton('    ~O~K    ',kbAltO,20,10,btDefault);
       AddButton('  ~C~ancel  ',kbAltC,40,10,btCancel);
    Result := Process(I);
    IF (Result = 1) AND (FileName <> '') THEN Edit := True ELSE Edit := False;
    IF (Result = 1) AND (FileName <> '') THEN Database^.FileName := PathOnly(FileName)+BaseNameOnly(FileName)+'.GBD';
    IF (Result = 1) THEN Database^.UserData := UserData;
  END;
  Dispose(EditD, Done);
END;
{+++ Change FILENAME +++++++++++++++++++++++++++++++++++++++++++++++++++++++}




{===========================================================================}
{=== Save DATABASE =========================================================}
{===========================================================================}
FUNCTION SaveDatabase:Boolean;
VAR
  Index    : Integer;
  Error    : Boolean;
  Header   : TFileHeader;
  Datafile : FILE;
  FileName : STRING;

  FUNCTION WriteRecord(ARecord:PRecord): Boolean;
  VAR Data:TFileRecord; W:Word;
  BEGIN
    UpdateGauge(Index+1,Database^.Count);
    WITH Data DO
    BEGIN
      Name     := RetStr(ARecord^.Name);
      Firm     := RetStr(ARecord^.Firm);
      FName    := RetStr(ARecord^.FName);
      RecType  := ARecord^.RecType;
      Video    := ARecord^.Video;
      Sound    := ARecord^.Sound;
      Hardware := ARecord^.Hardware;
      Special  := ARecord^.Special AND NOT _MARK;
      OS       := ARecord^.OS;
      FullSize := ARecord^.FullSize;
      ArchSize := ARecord^.ArchSize;
    END;
    {$I-}
        BlockWrite(DataFile,Data,SizeOf(Data),W);
    {$I+}
    WriteRecord := (IOResult = 0);
  END;

BEGIN
  SaveDatabase     := False;
  FileName         := Database^.FileName;
  Header.DataID    := DataFileID;
  Header.UserData  := Database^.UserData;
  Header.TotalRecs := GlobalInfo.Records.Total;

  Assign(Datafile,FileName);
  {$I-}
      Rewrite(Datafile,1);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
                          InfoBox(CreateError+NameOnly(FileName),True);
                          Exit;
                        END;
  InitGauge('Saving '+NameOnly(FileName));
  {$I-}
      BlockWrite(DataFile,Header,SizeOf(Header),Index);
  {$I+}
  FOR Index := 0 TO Database^.Count-1 DO
  BEGIN
    Error := NOT WriteRecord(Database^.At(Index));
    IF Error THEN Break;
  END;
  {$I-}
      Close(Datafile);
  {$I+}
  DoneGauge;
  IF Error
    THEN BEGIN
           InfoBox(SaveError+NameOnly(FileName),True);
           Exit;
         END
    ELSE BEGIN
           InfoBox(NameOnly(FileName)+' is saved!',False);
           DBAllNew := False;
           DBChanged := False;
           SaveDatabase := True;
         END;
END;

FUNCTION SaveAs: Boolean;
VAR Tmp:Byte;
BEGIN
  SaveAs := False;
  IF Edit(True) THEN
  BEGIN
    IF Exist(Database^.FileName)
      THEN BEGIN
             Tmp := AltPromptBox(NameOnly(Database^.FileName)+FileExist,True);
             IF Tmp = 1 THEN
               IF SaveDatabase THEN SaveAs := True;
           END
      ELSE IF SaveDatabase THEN SaveAs := True;
  END;
END;
{+++ SAVE DATABASE +++++++++++++++++++++++++++++++++++++++++++++++++++++++++}



{===========================================================================}
{=== LOAD DATABASE =========================================================}
{===========================================================================}
FUNCTION NewDatabaseFormat(FileName:STRING): Boolean;
VAR T:Text; S:STRING;
BEGIN
  Assign(T,FileName);
  {$I-}
      Reset(T);
      Readln(T,S);
      NewDatabaseFormat := (S = 'GBASE DATAFILE');
      Close(T);
  {$I-}
END;

FUNCTION OldDatabaseFormat(FileName:STRING): Boolean;
VAR T:Text; S:STRING;
BEGIN
  Assign(T,FileName);
  {$I-}
      Reset(T);
      Readln(T,S);
      OldDatabaseFormat := (S = 'GBASE FILE');
      Close(T);
  {$I-}
END;


FUNCTION LoadOLDDatabase: Boolean;
CONST
  CGA_     = $01;  EGA_    = $02;  VGA_     = $04;  SVGA_  = $08;
  ADLIB_   = $10;  SB_     = $20;  SBPRO_   = $40;  PAS16_ = $80;   GUS_   = $100;
  CRACKED_ = $200; MIN386_ = $400; MIN8RAM_ = $800; WIN_   = $1000;
TYPE
  TOldFileHeader = RECORD
    DataID       : ARRAY[1..12] OF Char;
    EOFMarker    : Byte;
    UserData     : STRING[40];
  END;
  TOldFileRecord = RECORD
     Name        : STRING[NameLength];
     Firm        : STRING[FirmLength];
     FName       : STRING[FNameLength];
     RecType     : Byte;
     Flags       : LongInt;
     FullSize    : LongInt;
     ArchSize    : LongInt;
  END;

VAR
  DataFile : FILE;
  FileName : STRING;
  Data     : TOldFileRecord;
  Header   : TOldFileHeader;
  Recs     : Word;
  Index    : Integer;
  Error    : Boolean;

  PROCEDURE ReadRecord; NEAR;
  VAR Readen  : Word;
      Name    : STRING[NameLength];
      Firm    : STRING[FirmLength];
      FName   : STRING[FNameLength];
      RecType : Byte;  { TypesDATA[RecType] }
      Video   : Byte;  { Bitmap - CGA EGA VGA SVGA }
      Sound   : Byte;  { Bitmap - ADLIB SB SBPRO SB16 PAS GUS ROLAND }
      Hardware: Byte;  { Bitmap - 8RAM 16RAM 386 486 }
      Special : Byte;  { Bitmap - CRACK MARK }
      OS      : Byte;  { OSesDATA[OS] }
      FullSize: LongInt;
      ArchSize: LongInt;
  BEGIN
    UpdateGauge(Index,Recs);
    Error := False;
    {$I-}
        BlockRead(DataFile,Data,SizeOf(Data),Readen);
    {$I+}
    IF IOResult <> 0
      THEN BEGIN
             Error := True;
             InfoBox(ReadError+NameOnly(FileName),True);
             Exit;
           END;
    Name    := Data.Name;
    Firm    := Data.Firm;
    FName   := Data.FName;
    RecType := Data.RecType;
    FullSize:= Data.FullSize;
    ArchSize:= Data.ArchSize;
    Video   := 0;
    Sound   := 0;
    Hardware:= 0;
    Special := 0;
    OS      := 1;
    WITH Data DO
    BEGIN
      IF (Flags AND CGA_)     <> 0 THEN Video := Video OR _CGA;
      IF (Flags AND EGA_)     <> 0 THEN Video := Video OR _EGA;
      IF (Flags AND VGA_)     <> 0 THEN Video := Video OR _VGA;
      IF (Flags AND SVGA_)    <> 0 THEN Video := Video OR _SVGA;
      IF (Flags AND ADLIB_)   <> 0 THEN Sound := Sound OR _ADLIB;
      IF (Flags AND SB_)      <> 0 THEN Sound := Sound OR _SB;
      IF (Flags AND SBPRO_)   <> 0 THEN Sound := Sound OR _SBPRO;
      IF (Flags AND PAS16_)   <> 0 THEN Sound := Sound OR _PAS;
      IF (Flags AND GUS_)     <> 0 THEN Sound := Sound OR _GUS;
{     IF (Flags AND MIN386_)  <> 0 THEN Hardware := Hardware OR _486;}
      IF (Flags AND MIN8RAM_) <> 0 THEN Hardware := Hardware OR _8RAM;
      IF (Flags AND CRACKED_) <> 0 THEN Special := Special OR _CRACK;
      IF (Flags AND WIN_)     <> 0 THEN OS := 2;
    END;
    Database^.Insert(New(PRecord, Init(Name,Firm,FName,
                                       RecType,
                                       Video,Sound,Hardware,Special,OS,
                                       FullSize,ArchSize)));
  END;

BEGIN
  LoadOLDDatabase := False;
  FileName := Database^.Filename;
  Assign(DataFile,FileName);
  {$I-}
      Reset(DataFile,1);
  {$I+}
  IF IOResult <> 0
    THEN BEGIN
           InfoBox(OpenError+NameOnly(FileName),True);
           Exit;
         END;
  {$I-}
      BlockRead(DataFile,Header,SizeOf(Header),Index);
  {$I+}
  InitDatabase;
  Database^.FileName := FileName;
  Database^.UserData := Header.UserData;
  InitGauge('Loading '+NameOnly(FileName));
  Recs  := (FileSize(DataFile)-SizeOf(Header)) DIV SizeOf(Data);
  Index := 0;
  Error := False;
  WHILE (Index<>Recs) AND NOT Error DO
  BEGIN
    ReadRecord;
    Inc(Index);
  END;
  DoneGauge;
  {$I-}
      Close(DataFile);
  {$I+}
  LoadOLDDatabase := NOT Error;
  UpdateGlobalInfo;
END; {LoadOLDDatabase}

FUNCTION LoadNEWDatabase: Boolean;
VAR
  DataFile : FILE;
  FileName : STRING;
  Header   : TFileHeader;
  Recs     : Word;
  Index    : Integer;
  Error    : Boolean;

  PROCEDURE ReadRecord; NEAR;
  VAR Data:TFileRecord; R:Word;
  BEGIN
    UpdateGauge(Index,Recs);
    Error := False;
    {$I-}
        BlockRead(DataFile,Data,SizeOf(Data),R);
    {$I+}
    IF IOResult <> 0
      THEN BEGIN
             Error := True;
             InfoBox(ReadError+NameOnly(FileName),True);
             Exit;
           END;
    WITH Data DO
    Database^.Insert(New(PRecord, Init(Name,Firm,FName,
                                       RecType,
                                       Video,Sound,Hardware,Special,OS,
                                       FullSize,ArchSize)));
  END;

BEGIN
  FileName := Database^.Filename;
  LoadNEWDatabase := False;

  IF OldDatabaseFormat(FileName)
    THEN BEGIN
           LoadNEWDatabase := LoadOLDDatabase;
           Exit;
         END;
  IF NOT NewDatabaseFormat(FileName)
    THEN BEGIN
           InfoBox(NameOnly(FileName)+NotGBFileError,True);
           Exit;
         END;

  Assign(DataFile,FileName);
  {$I-}
      Reset(DataFile,1);
  {$I+}
  IF IOResult <> 0
    THEN BEGIN
           InfoBox(OpenError+NameOnly(FileName),True);
           Exit;
         END;
  {$I-}
      BlockRead(DataFile,Header,SizeOf(Header),Index);
  {$I+}
  InitDatabase;
  Database^.FileName := FileName;
  Database^.UserData := Header.UserData;
  InitGauge('Loading '+NameOnly(FileName));
  Recs  := Header.TotalRecs;
  Index := 0;
  Error := False;
  WHILE (Index<>Recs) AND NOT Error DO
  BEGIN
    ReadRecord;
    Inc(Index);
  END;
  DoneGauge;
  {$I-}
      Close(DataFile);
  {$I+}
  LoadNEWDatabase := NOT Error;
  UpdateGlobalInfo;
END; {LoadNEWDatabase}

PROCEDURE LoadDatabase;
VAR TMP:Byte; FileName:STRING;
BEGIN
  IF DBChanged THEN
  BEGIN
    TMP := AltPromptBox(Modifyed,True);
    IF TMP = 1
      THEN CASE DBAllNew OF
             True: IF NOT SaveAs THEN Exit;
            False: IF NOT SaveDatabase THEN Exit;
           END;
    IF TMP = 3 THEN Exit;
  END;
  FileName := Database^.Filename;
  IF FileDialog('Open datafile','*.GBD',Database^.FileName) THEN
  BEGIN
    IF NOT LoadNEWDatabase
      THEN Database^.FileName := FileName
      ELSE BEGIN
             MainList^.LSTPosition := 1;
             MainList^.ChangeMaxTopics(MaxY-14, Database^.Count);
           END;
  END;
END;
{+++ LOAD DATABASE +++++++++++++++++++++++++++++++++++++++++++++++++++++++++}


{===========================================================================}
{=== CFG ROUTINES ==========================================================}
{===========================================================================}
PROCEDURE SaveCFG;
VAR CFG:Text; CFGName:STRING;
BEGIN
  CFGName := PathOnly(ParamStr(0))+CFGFilename;
  Assign(CFG,CFGName);
  {$I-}
      Rewrite(CFG);
      Writeln(CFG, Database^.Filename);
      Close(CFG);
  {$I+}
END;

FUNCTION LoadCFG: Boolean;
VAR CFG:Text; CFGName,Temp,St:STRING; OK:Boolean;
BEGIN
  OK      := False;
  LoadCFG := False;
  CFGName := PathOnly(ParamStr(0))+CFGFilename;
  Assign(CFG,CFGName);
  {$I-}
      Reset(CFG);
  {$I+}
  IF IOResult <> 0 THEN Exit;
  {$I-}
      Readln(CFG, St);
      Close(CFG);
  {$I+}
  Temp := St;
  IF StripBoth(Temp,' ') = '' THEN Exit;
  IF NOT Exist(Temp)
    THEN BEGIN
           GetDir(0,CFGName);
           IF CFGName[Length(CFGName)] <> '\' THEN CFGName := CFGName + '\';
           Temp := CFGName + NameOnly(St);
           IF NOT Exist(Temp)
             THEN BEGIN
                    Temp := St;
                    Temp[1] := CFGName[1];
                    IF Exist(Temp) THEN OK := True;
                  END
             ELSE OK := True;
         END
    ELSE OK := True;
  LoadCFG := OK;
  IF OK THEN Database^.Filename := Temp;
END;
{+++ CFG ROUTINES ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}





{===========================================================================}
{=== TEXT FILES PROCEEDING =================================================}
{===========================================================================}
FUNCTION GetVideo(ARecord:PRecord): STRING;
VAR S:STRING;
BEGIN
  S:='';
  IF GetFlag(ARecord,bVideo,_CGA ) THEN S := S+'CGA ' ELSE S := S+'    ';
  IF GetFlag(ARecord,bVideo,_EGA ) THEN S := S+'EGA ' ELSE S := S+'    ';
  IF GetFlag(ARecord,bVideo,_VGA ) THEN S := S+'VGA ' ELSE S := S+'    ';
  IF GetFlag(ARecord,bVideo,_SVGA) THEN S := S+'SVGA' ELSE S := S+'    ';
  GetVideo := S;
END;

FUNCTION GetSound(ARecord:PRecord): STRING;
VAR S:STRING;
BEGIN
  S:='';
  IF GetFlag(ARecord,bSound,_ADLIB ) THEN S := S+'AD '   ELSE S := S+'   ';
  IF GetFlag(ARecord,bSound,_SB    ) THEN S := S+'SB '   ELSE S := S+'   ';
  IF GetFlag(ARecord,bSound,_SBPRO ) THEN S := S+'SBP '  ELSE S := S+'    ';
  IF GetFlag(ARecord,bSound,_SB16  ) THEN S := S+'SB16 ' ELSE S := S+'     ';
  IF GetFlag(ARecord,bSound,_PAS   ) THEN S := S+'PAS '  ELSE S := S+'    ';
  IF GetFlag(ARecord,bSound,_GUS   ) THEN S := S+'GUS '  ELSE S := S+'    ';
  IF GetFlag(ARecord,bSound,_ROLAND) THEN S := S+'RD'    ELSE S := S+'  ';
  GetSound := S;
END;

FUNCTION GetOS(ARecord:PRecord):STRING;
VAR S:STRING;
BEGIN
  CASE ARecord^.OS OF
    1: S := '  DOS';
    2: S := 'WIN31';
    3: S := 'WIN95';
    4: S := ' OS/2';
  END;
  GetOS := S;
END;

FUNCTION GetSpecial(ARecord:PRecord): STRING;
VAR S:STRING;
BEGIN
  S:='';
  IF GetFlag(ARecord,bHardware,_8RAM ) THEN S := S+'8RAM '    ELSE S := S+'     ';
  IF GetFlag(ARecord,bHardware,_16RAM) THEN S := S+'16RAM '   ELSE S := S+'      ';
  IF GetFlag(ARecord,bHardware,_486  ) THEN S := S+'486 '     ELSE S := S+'    ';
  IF GetFlag(ARecord,bHardware,_P5   ) THEN S := S+'P5 '      ELSE S := S+'   ';
  IF GetCracked(ARecord)               THEN S := S+'CRACKED ' ELSE S := S+'        ';
  GetSpecial := S;
END;

PROCEDURE SaveTextFile(SelectedOnly:Boolean);
CONST Offsets: ARRAY[1..8] OF Byte = (45, 68, 84, 99, 112, 125, 144, 172);
VAR
  Index    : Integer;
  TextFile : Text;
  Question,
  FileName : STRING;
  Buffer   : Pointer;
  BufSize  : LongInt;
  Error    : Boolean;
  Line     : STRING;

  Recs,
  Total    : Word;
  FullSize : LongInt;
  ArchSize : LongInt;

  PROCEDURE InsBreaks(Ch1,Ch2,Ch3,Ch4:Char);
  VAR I:Byte;
  BEGIN
    Line       := Replicate(206,Ch4);
    Line[  1]  := Ch1;
    Line[206]  := Ch2;
    FOR I := 1 TO 8 DO Line[Offsets[I]] := Ch3;
  END;

  PROCEDURE WriteLine(ARecord:PRecord); NEAR;
  BEGIN
    IF (SelectedOnly) AND NOT (GetMarked(ARecord)) THEN Exit;
    WITH ARecord^ DO
    BEGIN
      Line :=  ' '+PadLeft   (RetStr(Name)      ,NameLength ,' ')+
              '  '+PadRight  (RetStr(Firm)      ,FirmLength ,' ')+
              '  '+PadCenter (TypesData[RecType],TypeLength ,' ');
      Line := Line+
              '  '+PadLeft   (PadLeft( BaseNameOnly(RetStr(FName)),8,' ')+' '+
                                        PadLeft(ExtOnly(RetStr(FName)),3,' '),FNameLength,' ')+
              '  '+PadRight  (AddComas(FullSize) ,10         ,' ')+
              '  '+PadRight  (AddComas(ArchSize) ,10         ,' ');
      Line := Line+
              '  '+GetVideo  (ARecord)+
              '  '+GetSound  (ARecord)+
              '  '+GetSpecial(ARecord)+GetOS(ARecord)+
              ' ';
     {$I-}
         Writeln(TextFile,Line);
     {$I+}
     IF IOResult <> 0 THEN Error := True;
    END;
    Inc(Recs);
    Inc(FullSize,(ARecord^.FullSize DIV 1024));
    Inc(ArchSize,(ARecord^.ArchSize DIV 1024));
    UpdateGauge(Recs,Total);
  END;

BEGIN
  Error    := False;
  Recs     := 0;
  FullSize := 0;
  ArchSize := 0;
  IF SelectedOnly
    THEN BEGIN
           Total    := GlobalInfo.Records.Marked;
           FileName := BaseNameOnly(Database^.FileName)+'.TAG';
           Question := 'Save SELECTED records in TEXT file?';
         END
    ELSE BEGIN
           Total    := GlobalInfo.Records.Total;
           FileName := BaseNameOnly(Database^.FileName)+'.ALL';
           Question := 'Save ALL records in TEXT file?';
         END;
  IF Total = 0 THEN Exit;
  IF NOT PromptBox(Question,False) THEN Exit;

  Assign(TextFile,FileName);
  SetFAttr(TextFile,0);
  {$I-}
      Rewrite(TextFile);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    InfoBox('Error creating '+FileName,True);
    Exit;
  END;
  IF MemAvail > 8192
    THEN IF MemAvail < 64096
           THEN BufSize := MemAvail - 2048
           ELSE BufSize := 60000
    ELSE BufSize := 0;
  IF BufSize <> 0 THEN GetMem(Buffer,BufSize);
  IF BufSize <> 0 THEN SetTextBuf(TextFile,Buffer^,BufSize);

  InitGauge('Saving '+FileName);
  {$I-}
      IF Length(Database^.UserData) <> 0 THEN
      BEGIN
        Writeln(TextFile);
        Writeln(TextFile,'',Replicate(62,'')                   ,'');
        Writeln(TextFile,'',PadCenter(Database^.UserData,62,' '),'');
        Writeln(TextFile,'',Replicate(62,'')                   ,'');
      END;
      Writeln(TextFile);
      InsBreaks('','','','');   Writeln(TextFile,Line);
      InsBreaks('','','',' ');   OverWrite(21 ,Line,'NAME');
                                    OverWrite(52 ,Line,'CREATED BY');
                                    OverWrite(74 ,Line,'TYPE');
                                    OverWrite(88 ,Line,'FILENAME');
                                    OverWrite(101,Line,'FULL SIZE');
                                    OverWrite(114,Line,'ARCH SIZE');
                                    OverWrite(132,Line,'VIDEO');
                                    OverWrite(156,Line,'SOUND');
                                    OverWrite(186,Line,'SPECIAL');
      Writeln(TextFile,Line);
      InsBreaks('','','','');   Writeln(TextFile,Line);
  {$I+}
  FOR Index:=0 TO Database^.Count-1 DO
  BEGIN
    WriteLine(Database^.At(Index));
    IF Error THEN Break;
  END;
  {$I-}
      InsBreaks('','','','');  Writeln(TextFile,Line+#13#10);

      Writeln(TextFile,'',Replicate(NameLength+2,'')                                                  ,'');
      Writeln(TextFile,'',PadCenter('Statistics',NameLength+2,' ')                                     ,'');
      Writeln(TextFile,'',Replicate(NameLength+2,'')                                                  ,'');
      Writeln(TextFile,'',PadLeft(' Total RECORDS',21,' ')  +' '+PadRight(AddComas(Total),20,' ')      ,' ');
      Writeln(TextFile,'',PadLeft(' Total FULL SIZE',21,' ')+' '+PadRight(AddComas(FullSize),17,' '),' KB ');
      Writeln(TextFile,'',PadLeft(' Total ARCH SIZE',21,' ')+' '+PadRight(AddComas(ArchSize),17,' '),' KB ');
      Writeln(TextFile,'',Replicate(NameLength+2,'')                                                  ,'');
      Writeln(TextFile,'',PadCenter('This catalog is created with GBASE',NameLength+2,' ')             ,'');
      Writeln(TextFile,'',Replicate(NameLength+2,'')                                                  ,'');

      Close(TextFile);
      SetFAttr(TextFile, Archive);
  {$I+}
  IF BufSize <> 0 THEN FreeMem(Buffer,BufSize);
  DoneGauge;

  IF Error
    THEN InfoBox('Error writing in '+FileName,True)
    ELSE InfoBox(FileName+' is created',False);
END;

PROCEDURE SaveDESCRIPTION(Advanced:Boolean);
VAR
  Index    : Integer;
  DescFile : Text;
  Buffer   : Pointer;
  BufSize  : LongInt;
  Error    : Boolean;
  Question : STRING;

  PROCEDURE WriteOneDescription(ARecord:PRecord); NEAR;
  VAR Line: STRING;

    FUNCTION GetVid:STRING; BEGIN GetVid := GetVideo(ARecord)+PadRight(GetOS(ARecord),18,' '); END;

  BEGIN
    UpdateGauge(Index+1,Database^.Count);
    WITH ARecord^ DO
    BEGIN
      IF FName = NIL THEN Exit;
      IF Advanced
        THEN BEGIN
               Line := PadLeft(GetFName(ARecord),13,' ')+PadLeft(Name^,40,' ');
               {$I-}
                   Write(DescFile,Line);
               {$I+}
               IF IOResult = 0
                 THEN BEGIN
                        Line := PadLeft(' '+GetVid,40,' ')+
                                PadLeft(' '+GetSound(ARecord),40,' ')+
                                PadLeft(' '+GetSpecial(ARecord),40,' ')+
                                PadLeft(' '+GetType(ARecord),40,' ')+
                                        ' '+AddComas(FullSize)+' Bytes';
                       {$I-}
                           Writeln(DescFile,Line);
                       {$I+}
                       IF IOResult <> 0 THEN Error := True;
                      END
                 ELSE Error := True;
             END
        ELSE BEGIN
               Line := PadLeft(GetFName(ARecord),13,' ')+'-- '+Name^;
               {$I-}
                   Writeln(DescFile,Line);
               {$I+}
               IF IOResult <> 0 THEN Error := True;
             END;
    END;
  END;

BEGIN
  Question := 'Save DESCRIPT.ION?';
  IF Advanced THEN Insert('ADVANCED ',Question,6);
  IF NOT PromptBox(Question,False) THEN Exit;

  Error := False;
  Delete(Question,1,4);
  Delete(Question,Length(Question),1);
  Insert('Saving',Question,1);

  Assign(DescFile,'DESCRIPT.ION');
  SetFAttr(DescFile,0);
  {$I-}
      Rewrite(DescFile);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    InfoBox('Error creating DESCRIPT.ION',True);
    Exit;
  END;
  IF MemAvail > 8192
    THEN IF MemAvail < 64096
           THEN BufSize := MemAvail - 2048
           ELSE BufSize := 60000
    ELSE BufSize := 0;
  IF BufSize <> 0 THEN GetMem(Buffer,BufSize);
  IF BufSize <> 0 THEN SetTextBuf(DescFile,Buffer^,BufSize);

  InitGauge(Question);
  {$I-}
      Writeln(DescFile,'DESCRIPT.ION 4DOS Description file');
  {$I+}
  FOR Index:=0 TO Database^.Count-1 DO
  BEGIN
    WriteOneDescription(Database^.At(Index));
    IF Error THEN Break;
  END;
  {$I-}
      Close(DescFile);
      SetFAttr(DescFile, Hidden OR Archive);
  {$I+}
  IF BufSize <> 0 THEN FreeMem(Buffer,BufSize);
  DoneGauge;
  Delete(Question,1,7);
  IF Error
    THEN InfoBox('Error writing in DESCRIPT.ION',True)
    ELSE InfoBox(Question+' is created',False);
END;
{+++ TEXT FILES PROCEEDING +++++++++++++++++++++++++++++++++++++++++++++++++}




{===========================================================================}
{=== CLIPBOARD PROCEDURES ==================================================}
{===========================================================================}
PROCEDURE Cut;
VAR Index:Integer; ARecord:PRecord;
BEGIN
  IF (GlobalInfo.Records.Total = 1) OR
     (GlobalInfo.Records.Marked= 0) OR
     (GlobalInfo.Records.Total = GlobalInfo.Records.Marked) THEN Exit;
  DisposeClipboard;
  New(Clipboard,Init(1,1));
  Index := 0;
  REPEAT
    ARecord := Database^.At(Index);
    IF GetMarked(ARecord) THEN
    BEGIN
      WITH ARecord^ DO
         Clipboard^.Insert( New(PRecord,
                                Init(RetStr(Name),RetStr(Firm),RetStr(FName),
                                     RecType,Video,Sound,Hardware,Special,OS,
                                     FullSize,ArchSize)));
      Database^.AtFree(Index);
      Dec(Index)
    END;
    Inc(Index);
  UNTIL Index = Database^.Count;
  UpdateGlobalInfo;
  MainList^.ChangeMaxTopics(MaxY-14,Database^.Count);
  DBChanged := True;
END;

PROCEDURE Copy;
VAR Index:Integer; ARecord:PRecord; a: integer;
BEGIN
  IF GlobalInfo.Records.Marked = 0 THEN Exit;
  DisposeClipboard;
  New(Clipboard,Init(1,1));
  Index := 0;
  FOR Index := 0 TO Database^.Count-1 DO
  BEGIN
    ARecord := DataBase^.At(Index);
    IF GetMarked(ARecord) THEN
    BEGIN
      WITH ARecord^ DO
         Clipboard^.Insert( New(PRecord,
                                Init(RetStr(Name),RetStr(Firm),RetStr(FName),
                                     RecType,Video,Sound,Hardware,Special,OS,
                                     FullSize,ArchSize)));
    END;
  END;
END;

PROCEDURE Paste;
VAR Index:Integer; ARecord:PRecord;
BEGIN
  IF Clipboard=NIL THEN Exit;
  IF (Database^.Count+Clipboard^.Count) > MaxRecords THEN BEGIN InfoBox(TooManyRecords,True); Exit; END;
  FOR Index := 0 TO CLipboard^.Count-1 DO
  BEGIN
    ARecord := Clipboard^.At(Index);
    WITH ARecord^ DO
       Database^.Insert( New(PRecord,
                             Init(RetStr(Name),RetStr(Firm),RetStr(FName),
                                  RecType,Video,Sound,Hardware,Special,OS,
                                  FullSize,ArchSize)));
  END;
  UpdateGlobalInfo;
  MainList^.ChangeMaxTopics(MaxY-14,Database^.Count);
  DBChanged := True;
END;
{+++ CLIPBOARD PROCEDURES ++++++++++++++++++++++++++++++++++++++++++++++++++}


{===========================================================================}
{=== VIEW CLIPBOARD PROCEDURES =============================================}
{===========================================================================}
FUNCTION TClipboardList.__GetLine(ListPos:Integer): STRING;
VAR ARecord: PRecord;
BEGIN
  ARecord := Clipboard^.At(ListPos-1);
  __GetLine := ' '+PadLeft (ARecord^.Name^  ,NameLength,' ')+' '+
               ' '+PadRight(GetType(ARecord),TypeLength,' ');
END;

PROCEDURE TClipboardList.__IdleListCall(ListPos: Integer);
VAR ARecord: PRecord;
BEGIN
  ARecord := Clipboard^.At(ListPos-1);
  DrawInformation(ARecord);
END;

PROCEDURE ViewCLipboard;
BEGIN
  IF Clipboard=NIL THEN Exit;
  OpenWin(10,4,59,MaxY-16,$5D,$5F,Single1,'View clipboard');
  New(ClipList, Init(11,5,
                     58,MaxY-17,
                     Clipboard^.Count,
                     False,
                     True,14,MaxY-12,'',
                     True,69,5,MaxY-13,
                     lPurplePal));
  ClipList^.Process;
  Dispose(ClipList, Done);
  RmWin;
END;
{+++ VIEW CLIPBOARD PROCEDURES +++++++++++++++++++++++++++++++++++++++++++++}




{===========================================================================}
{=== Database PROCEDURES ===================================================}
{===========================================================================}
FUNCTION AddEditDialog(DlgTitle:STRING): Boolean;
LABEL Again;
VAR
  Index,
  Result    : Integer;
  TypeDTA   : PStrArray;
  AddEditDlg: PDialog;

BEGIN
  AddEditDialog := False;

  IF MemAvail < MinMemory THEN BEGIN InfoBox(LowMemError,True); Exit; END;

  New(TypeDTA, Init);
  FOR Index := 1 TO MaxTypes DO TypeDTA^.AddStr(TypesData[Index]);
  New(AddEditDlg, Init(13,MaxY DIV 2-10,57,22,DefaultDialogPAL,Single1,DlgTitle));
  WITH AddEditDlg^ DO
  BEGIN
    AddTxtInputLine(4,2,'~N~ame' ,kbAltN,9,2,NameLength ,ilProperNorm,DlgDATA.Name);
    AddTxtInputLine(4,3,'F~i~rm' ,kbAltI,9,3,FirmLength ,ilUpper     ,DlgDATA.Firm);
    AddTxtInputLine(4,4,'~F~ile' ,kbAltF,9,4,FNameLength,ilFileName  ,DlgDATA.FName);

    AddComboBox(4,5,'~T~ype' ,kbAltT,9,5,TypeLength,MaxTypes,Single1,DlgDATA.RecType,TypeDTA);

    AddNumInputLine(31,4,'F~u~ll size' ,kbAltU,41,4,0,99999999,DlgDATA.FullSize);
    AddNumInputLine(31,5,'~A~rch size' ,kbAltA,41,5,0,99999999,DlgDATA.ArchSize);

   AddCheckBoxes(3,7,'~V~ideo',kbAltV,9,7,DlgDATA.Video);
     AddCheckBox('CGA        ',0);
     AddCheckBox('EGA        ',0);
     AddCheckBox('VGA        ',0);
     AddCheckBox('Super VGA  ',0);

   AddCheckBoxes(3,12,'Soun~d~',kbAltD,9,12,DlgDATA.Sound);
     AddCheckBox('Adlib      ',0);
     AddCheckBox('SB         ',0);
     AddCheckBox('SB Pro     ',0);
     AddCheckBox('SB 16/AWE32',0);
     AddCheckBox('PAS/PAS 16 ',0);
     AddCheckBox('Gravis     ',0);
     AddCheckBox('Roland     ',0);

   AddCheckBoxes(27,7,'~H~ardware',kbAltH,36,7,DlgDATA.Hardware);
     AddCheckBox('8MB Ram    ',0);
     AddCheckBox('16MB Ram   ',0);
     AddCheckBox('Minimum 486',0);
     AddCheckBox('Minimum P5 ',0);

 AddRadioButtons(28,12,'Host O~S~',kbAltS,36,12,DlgDATA.OS);
  AddRadioButton('DOS        ',0);
  AddRadioButton('Windows 3.1',0);
  AddRadioButton('Windows 95 ',0);
  AddRadioButton('OS/2       ',0);

 AddRadioButtons(28,17,'C~r~acked',kbAltR,36,17,DlgDATA.Crack);
  AddRadioButton('Yes CRACKED',0);
  AddRadioButton('No it''s not',0);

    AddButtons;
       AddButton('    ~O~K    ',kbAltO,15,20,btDefault);
       AddButton('  ~C~ancel  ',kbAltC,35,20,btCancel);

Again:
    Result := Process(1);

    IF ((Result = 1) AND (StripBoth(DlgData.Name,' ')=''))
      THEN BEGIN
             InfoBox('You forget to enter the NAME',True);
             InitPallette(DefaultDialogPAL);
             GOTO Again;
           END;
    IF Result = 1 THEN AddEditDialog := True;
  END;
  Dispose(TypeDTA, Done);
  Dispose(AddEditDlg, Done);
  PosCursor(80,MaxY); Cursor(Off);
END;

PROCEDURE InsRECORD;
VAR Index:Integer; ARecord:PRecord; Special:Word; ArchSizeLarger: Boolean;
BEGIN
  IF GlobalInfo.Records.Total = 1000 THEN BEGIN InfoBox(TooManyRecords,True); Exit; END;
  WITH DlgDATA DO
  BEGIN
    Name      := '';
    Firm      := '';
    FName     := '';
    RecType   := MaxTypes;
    FullSize  := '';
    ArchSize  := '';
    Video     := $00;
    Sound     := $00;
    Hardware  := $00;
    OS        := $01;
    Crack     := 2;
  END;
  IF AddEditDialog('Add record') THEN
  BEGIN
    Special        := 0;
    ArchSizeLarger := False;
    IF DlgDATA.Crack = 1 THEN Special := Special OR _CRACK;
    WITH DlgDATA DO
    BEGIN
      Database^.Insert(New(PRecord,
        Init(Name,Firm,FName,RecType,Video,Sound,
             Hardware,Special,OS,StrToInt(FullSize),StrToInt(ArchSize))));
      IF StrToInt(ArchSize) > StrToInt(FullSize) THEN ArchSizeLarger := True;
    END;
    FOR Index := 0 TO Database^.Count-1 DO
    BEGIN
      ARecord := Database^.At(Index);
      IF ARecord^.Name^ = DlgDATA.Name THEN Break;
    END;
    IF ArchSizeLarger THEN InfoBox(ASizeLarger,True);
    UpdateGlobalInfo;
    MainList^.LSTPosition := Index + 1;
    MainList^.ChangeMaxTopics(MaxY-14, Database^.Count);
    DBChanged := True;
  END;
END;

PROCEDURE EditRECORD;
VAR Index:Integer; ARecord:PRecord; Special:Word; ArchSizeLarger: Boolean;
BEGIN
  ARecord := Database^.At(CurrentREC);
  WITH DlgDATA DO
  BEGIN
    Name      := RetStr(ARecord^.Name);
    Firm      := RetStr(ARecord^.Firm);
    FName     := RetStr(ARecord^.FName);
    RecType   := ARecord^.RecType;
    FullSize  := IntToStr(ARecord^.FullSize);
    ArchSize  := IntToStr(ARecord^.ArchSize);
    Video     := ARecord^.Video;
    Sound     := ARecord^.Sound;
    Hardware  := ARecord^.Hardware;
    OS        := ARecord^.OS;
    IF GetCracked(ARecord)
      THEN Crack := 1
      ELSE Crack := 2;
  END;
  IF AddEditDialog('Edit record') THEN
  BEGIN
    Special := 0;
    ArchSizeLarger := False;
    IF GetMarked(ARecord) THEN Special := Special OR _MARK;
    IF DlgDATA.Crack = 1  THEN Special := Special OR _CRACK;
    WITH DlgDATA DO
    BEGIN
      Database^.AtFree(CurrentREC);
      Database^.Insert(New(PRecord,
        Init(Name,Firm,FName,RecType,Video,Sound,
             Hardware,Special,OS,StrToInt(FullSize),StrToInt(ArchSize))));
      IF StrToInt(ArchSize) > StrToInt(FullSize) THEN ArchSizeLarger := True;
    END;
    FOR Index := 0 TO Database^.Count-1 DO
    BEGIN
      ARecord := Database^.At(Index);
      IF ARecord^.Name^ = DlgDATA.Name THEN Break;
    END;
    IF ArchSizeLarger THEN InfoBox(ASizeLarger,True);
    UpdateGlobalInfo;
    MainList^.LSTPosition := Index + 1;
    MainList^.ReDraw;
    DBChanged := True;
  END;
END;

PROCEDURE DeleteRECORD;
BEGIN
  IF (GlobalInfo.Records.Total = 1) THEN Exit;
  IF PromptBox(DelRecord,True) THEN
  BEGIN
    Database^.AtFree(CurrentREC);
    UpdateGlobalInfo;
    MainList^.ChangeMaxTopics(MaxY-14, Database^.Count);
    DBChanged := True;
  END;
END;

PROCEDURE DeleteMARKED;
VAR Index:Integer; ARecord:PRecord;
BEGIN
  IF (GlobalInfo.Records.Total = 1) OR
     (GlobalInfo.Records.Marked= 0) OR
     (GlobalInfo.Records.Total = GlobalInfo.Records.Marked) THEN Exit;
  IF PromptBox(DelAllMarked,True) THEN
  BEGIN
    Index := 0;
    REPEAT
      ARecord := Database^.At(Index);
      IF GetMarked(ARecord) THEN
      BEGIN
        Database^.AtFree(Index);
        Dec(Index)
      END;
      Inc(Index);
    UNTIL Index = Database^.Count;
    UpdateGlobalInfo;
    MainList^.ChangeMaxTopics(MaxY-14, Database^.Count);
    DBChanged := True;
  END;
END;

PROCEDURE NewDatabase;
VAR SMethod:TSortMetod; Ascending:Boolean; TMP:Byte;
BEGIN
  IF DBChanged THEN
  BEGIN
    TMP := AltPromptBox(Modifyed,True);
    IF TMP = 1
      THEN CASE DBAllNew OF
             True: IF NOT SaveAs THEN Exit;
            False: IF NOT SaveDatabase THEN Exit;
           END;
    IF TMP = 3 THEN Exit;
  END;
  SMethod   := Database^.SortMetod;
  Ascending := Database^.Ascending;
  DisposeDatabase;
  Database := New(PRecordsCollection, Init(1,1));
  Database^.SortMetod := SMethod;
  Database^.Ascending := Ascending;
  Database^.Duplicates:= True;
  Database^.UserData  := '';
  Database^.FileName  := '';
  Database^.Insert(New(PRecord,Init('New','','',MaxTypes,$00,$00,$00,$00,1,0,0)));
  CurrentREC := 0;
  MainList^.ChangeMaxTopics(MaxY-14,1);
  ClearText(2,3,79,MaxY-12,$17);
  EditRECORD;
  DBAllNew  := True;
  DBChanged := True;
END;
{+++ Database PROCEDURES +++++++++++++++++++++++++++++++++++++++++++++++++++}





{===========================================================================}
{=== MainList^ PROCEDURES ==================================================}
{===========================================================================}
FUNCTION TRecordsList.__GetSelected(ListPos:Integer): Boolean;
VAR ARecord: PRecord;
BEGIN
  ARecord := Database^.At(ListPos-1);
  __GetSelected := GetMarked(ARecord);
END;

PROCEDURE TRecordsList.__SetSelected(ListPos:Integer; Selected:Boolean);
VAR ARecord: PRecord;
BEGIN
  ARecord := Database^.At(ListPos-1);
  SetMarked(ARecord, Selected);
  IF Selected { UPDATE GlobalInfo.Marked }
    THEN BEGIN
           Inc(GlobalInfo.Records.Marked);
           IF GetCracked(ARecord) THEN Inc(GlobalInfo.Cracked.Marked);
           Inc(GlobalInfo.FullSize.Marked,ARecord^.FullSize DIV 1024);
           Inc(GlobalInfo.ArchSize.Marked,ARecord^.ArchSize DIV 1024);
         END
    ELSE BEGIN
           Dec(GlobalInfo.Records.Marked);
           IF GetCracked(ARecord) THEN Dec(GlobalInfo.Cracked.Marked);
           Dec(GlobalInfo.FullSize.Marked,ARecord^.FullSize DIV 1024);
           Dec(GlobalInfo.ArchSize.Marked,ARecord^.ArchSize DIV 1024);
         END
END;

FUNCTION TRecordsList.__GetLine(ListPos:Integer): STRING;
VAR ARecord: PRecord; AName,AType,AFirm: STRING;
BEGIN
  ARecord := Database^.At(ListPos-1);
  AName := ' '+PadLeft  (ARecord^.Name^  ,NameLength,' ');
  AType := ' '+PadCenter(GetType(ARecord),TypeLength,' ');
  AFirm := ' '+PadRight (GetFirm(ARecord),FirmLength,' ');
  __GetLine := AName+AType+AFirm;
END;

PROCEDURE TRecordsList.__IdleListCall(ListPos:Integer);
VAR ARecord: PRecord;
BEGIN
  ARecord    := Database^.At(ListPos-1);
  CurrentREC := ListPos-1;
  DrawInformation(ARecord);
END;


PROCEDURE TRecordsList.__HookListKeys(ListPos: Integer; VAR PressedKey:Word);
VAR TMP: Byte;

  PROCEDURE DoAdvancedSelection;
  VAR Index:Integer; ARecord:PRecord;
  BEGIN
    IF (PressedKey=kbCtrlA) AND
       (GlobalInfo.Records.Marked = GlobalInfo.Records.Total) THEN PressedKey := kbCtrlU;
    FOR Index:=0 TO Database^.Count-1 DO
    BEGIN
      ARecord := DataBase^.At(Index);
      CASE PressedKey OF
        kbCtrlA: SetMarked(ARecord, True);
        kbCtrlU: SetMarked(ARecord, False);
        kbCtrlI: SetMarked(ARecord, NOT GetMarked(ARecord));
      END;
    END;
    UpdateGlobalInfo;
    ReDraw; { ReDraw LIST }
  END;

BEGIN
  MenuHandle(PressedKey);
  CASE PressedKey OF

       kbF1: Help(1);
       kbF2: IF DBAllNew
                THEN SaveAs
                ELSE IF PromptBox('Save database file?',False) THEN SaveDatabase;

      kbSF2: SaveAs;
       kbF3: LoadDatabase;

       kbF4: SaveTextFile(False);
       kbF5: SaveTextFile(True);

       kbF6: SaveDescription(False);
       kbF7: SaveDescription(True);

      kbEsc: IF DBChanged THEN
             BEGIN
               PressedKey := 0;
               TMP := AltPromptBox(Modifyed,True);
               IF TMP = 1
                 THEN CASE DBAllNew OF
                        True: IF SaveAs       THEN PressedKey := kbEsc;
                       False: IF SaveDatabase THEN PressedKey := kbEsc;
                      END;
               IF TMP = 2 THEN PressedKey := kbEsc;
             END;

       kbF9: About;

      kbIns: InsRECORD;
      kbTab: EditRECORD;
      kbDel: DeleteRECORD;

    kbCtrlD: DeleteMARKED;

    kbCtrlA,
    kbCtrlU,
    kbCtrlI: DoAdvancedSelection;

    kbCtrlS: Sort;
    kbCtrlO: IF GlobalInfo.Records.Total <> 1 THEN
             BEGIN
               Database^.ReSort(Database^.SortMetod, NOT Database^.Ascending);
               MainList^.ReDraw;
             END;

    kbCtrlB: IF Edit(False) THEN DBChanged := True; {Edit USERDATA}

    kbCtrlX: Cut;
    kbCtrlC: Copy;
    kbCtrlV: Paste;
  kbCtrlF10: ViewClipboard;
    kbCtrlE: DisposeClipboard;

    kbAltF9: SetScreen(NOT Condensed);
  END;
  ModifyMenu;
END;
{+++ END OF MainList^ PROCEDURES +++++++++++++++++++++++++++++++++++++++++++}





PROCEDURE __WatchMenu(Main,Sub: Byte); FAR;
BEGIN
  IF (Main=2) AND (Sub=1 ) THEN NewDatabase;
{  IF (Main=2) AND (Sub=12) THEN DosShell;}
  IF (Main=5) AND (Sub=3 ) THEN Help(2);
  IF (Main=5) AND (Sub=4 ) THEN Help(3);
  IF (Main=5) AND (Sub=5 ) THEN Help(4);
  IF (Main=5) AND (Sub=6 ) THEN Help(5);
  IF (Main=5) AND (Sub=7 ) THEN Help(6);
END;

PROCEDURE InitMenu;
VAR St: STRING;
BEGIN
  NewSubMenu('',kbAltSpace);
   NewItem('~About     ', 'F9', kbF9);

  NewSubMenu('File',kbAltF);
   NewItem('~New','',0);
   NewItem('~Open...','F3',kbF3);
   NewItem('~Save','F2',kbF2);
   NewItem('Save ~as...','Shift+F2',kbSF2);
   NewLine;
   NewItem('Save as ~textfile','F4',kbF4);
   NewItem('Save s~elected as textfile','F5',kbF5);
   NewLine;
   NewItem('Save DESCRIPT.~ION','F6',kbF6);
   NewItem('Save Advan~ced DESCRIPT.ION','F7',kbF7);
   NewLine;
{   NewItem('~DOS Shell','',0);
   NewLine;}
   NewItem('E~xit from GBASE','ESC',kbEsc);

  NewSubMenu('Edit',kbAltE);
   NewItem('Cu~t','Ctrl+X',kbCtrlX);
   NewItem('~Copy','Ctrl+C',kbCtrlC);
   NewItem('~Paste','Ctrl+V',kbCtrlV);
   NewLine;
   NewItem('~View clipboard','Ctrl-F10',kbCtrlF10);
   NewLine;
   NewItem('~Empty clipboard','Ctrl-E',kbCtrlE);

  NewSubMenu('Database',kbAltD);
   NewItem('~Add record','Ins',kbIns);
   NewItem('~Edit record','Tab',kbTab);
   NewItem('~Delete record','Del',kbDel);
   NewLine;
   NewItem('D~elete selected','Ctrl+D',kbCtrlD);
   NewLine;
   NewItem('Edit des~cription','Ctrl+B',kbCtrlB);
   NewLine;
   NewItem('Select ~all','Ctrl+A',kbCtrlA);
   NewItem('~UnSelect all','Ctrl+U',kbCtrlU);
   NewItem('~Invert selection','Ctrl+I',kbCtrlI);
   NewLine;
   NewItem('~Sort by...','NAME',kbCtrlS);
   NewItem('Sorting ~order','ASCENDING',kbCtrlO);

  NewSubMenu('Help',kbAltH);
   NewItem('~Help','F1',kbF1);
   NewLine;
   NewItem('~File','',0);
   NewItem('D~ialog','',0);
   NewItem('~Database','',0);
   NewItem('~Selection','',0);
   NewItem('~Clipboard','',0);

   MenuBorder := Single1;

   MenuDispacher := __WatchMenu;
END;




{===========================================================================}
{=== LOAD DATABASE =========================================================}
{===========================================================================}
PROCEDURE ShowLOGO;
{$I GBASE52\GB_LOGO.PAS}
BEGIN
  SetNormalLines;
  Cursor(Off);
  SetBlink(False);
  PosCursor(1,MaxY-1);
  PartRestore(1,MaxY DIV 2-11,80,(MaxY DIV 2-11)+24,GBaseLogo);
END;


PROCEDURE ErrorExit;
BEGIN
  IF ExitCode <> 0
    THEN BEGIN
           DisposeAll;
           ShowLOGO;
           InfoBox('Internal program error '+IntToStr(ExitCode),True);
           Cursor(On);
           SetBlink(True);
           SetPAL(OrgPAL);
           ExitProc := SaveExit;
           Halt(ExitCode);
         END
    ELSE ExitProc := SaveExit;
END;



PROCEDURE Initialize;
VAR BeginNew:Byte; MaxRecs:Integer; FName:STRING;

  PROCEDURE FastQuit;
  BEGIN
    Cursor(On);
    SetBlink(True);
    SetPAL(OrgPAL);
    Halt;
  END;

BEGIN
  SaveExit  := ExitProc;
  ExitProc  := @ErrorExit;

  Condensed := False;
  Clipboard := NIL;
  Database  := NIL;
  MainList  := NIL;
  InitDatabase;

  ShowLOGO;
  SetPAL(AltPAL);
  MaxKeyboardSpeed;

  IF LoadCFG
    THEN BEGIN
           BeginNew  := 2;
           IF NOT LoadNEWDatabase THEN FastQuit;
         END
    ELSE BEGIN
           BeginNew  := BeginNewDatabase;
           IF BeginNew=3 THEN FastQuit; {ESC Pressed}
           IF BeginNew=2 THEN BEGIN
                                IF NOT FileDialog('Open datafile','*.GBD',Database^.FileName)
                                  THEN FastQuit;
                                IF NOT LoadNEWDatabase THEN FastQuit;
                               END;
         END;

  InitMenu;
  New(MainList, Init(2,3,78,MaxY-14,Database^.Count,True,True,14,MaxY-11,'',True,80,3,MaxY-12,lDefaultPal));
  SetScreen(Condensed);

  IF BeginNew=1 THEN NewDatabase;
END;

PROCEDURE QuitGBASE;
BEGIN
  ClrScr(7);
  SetPAL(OrgPAL);
  ShowLogo;
  Cursor(On);
  SetBlink(True);
  Halt;
END;

BEGIN
  IF MemAvail < 276000
    THEN BEGIN
           Writeln(#13#10#13#10#13#10#13#10#13#10);
           WriteHi(1,WhereY-5,$04,$0C,'Not enough memory to run ~GBASE~ !!!');
           WriteHi(1,WhereY-3,$02,$0A,'Remove some TSRs or DEVICE DRIVERS because');
           WriteHi(1,WhereY-2,$02,$0A,'the program needs at least ~380KB~ of conventional');
           WriteHi(1,WhereY-1,$02,$0A,'memory to work properly.');
           Halt(127);
         END;
  Initialize;
  MainList^.Process;
  SaveCFG;
  DisposeAll;
  QuitGBASE;
END.
